#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>

#define TASKNAME "connect"
typedef double real;

const int MaxN = 205;
const real MaxC = 1E25;

int a [MaxN] [MaxN];
int x [MaxN], y [MaxN];
int ans1 [MaxN], ans2 [MaxN];
bool b [MaxN];
int n;

int rho2 (int x1, int y1, int x2, int y2)
{
 return (x2 - x1) * (x2 - x1) + (y2 - y1) * (y2 - y1);
}

int main (void)
{
 int i, j, k, l, m;
 real cur, res;
 freopen (TASKNAME ".in", "rt", stdin);
 freopen (TASKNAME ".out", "wt", stdout);
 while (scanf (" %d", &n) != EOF)
 {
  for (i = 0; i < n; i++)
   scanf (" %d %d", &x[i], &y[i]);
  for (i = 0; i < n; i++)
   for (j = 0; j < n; j++)
    a[i][j] = rho2 (x[i], y[i], x[j], y[j]);
  res = 0.0;
  memset (b, 0, sizeof (b));
  b[0] = true;
  for (k = 0; k < n - 1; k++)
  {
   cur = MaxC;
   l = m = -1;
   for (i = 0; i < n; i++) if (b[i])
    for (j = 0; j < n; j++) if (!b[j])
     if (cur > a[i][j])
     {
      cur = a[i][j];
      l = i;
      m = j;
     }
   res += sqrt (cur);
   ans1[k] = l + 1;
   ans2[k] = m + 1;
   b[m] = true;
  }
  assert (k == n - 1);
  printf ("%.6lf\n", res);
  printf ("%d\n", k);
  for (i = 0; i < k; i++)
   printf ("%d %d\n", ans1[i], ans2[i]);
 }
 return 0;
}
