#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <string>
#include <vector>

#define TASKNAME "connect"
typedef double real;
using namespace std;

const int MaxN = 205;
const real MaxC = 1E25;

int x [MaxN], y [MaxN];
int ans1 [MaxN * MaxN], ans2 [MaxN * MaxN];
int c [MaxN];
int n;

int rho2 (int x1, int y1, int x2, int y2)
{
 return (x2 - x1) * (x2 - x1) + (y2 - y1) * (y2 - y1);
}

struct edge
{
 int p, q, len;

 edge (int i, int j)
 {
  p = i;
  q = j;
  len = rho2 (x[i], y[i], x[j], y[j]);
 }
};

bool operator < (edge e, edge f)
{
 return e.len < f.len;
}

int main (void)
{
 int i, j, k;
 real res;
 freopen (TASKNAME ".in", "rt", stdin);
 freopen (TASKNAME ".out", "wt", stdout);
 while (scanf (" %d", &n) != EOF)
 {
  vector <edge> e;
  for (i = 0; i < n; i++)
   scanf (" %d %d", &x[i], &y[i]);
  for (i = 0; i < n; i++)
   for (j = 0; j < n; j++)
    e.push_back (edge (i, j));
  sort (e.begin (), e.end ());
  for (i = 0; i < MaxN; i++)
   c[i] = i;
  res = 0.0;
  k = 0;
  for (i = 0; i < (int) e.size (); i++)
   if (c[e[i].p] != c[e[i].q])
   {
    for (j = 0; j < n; j++)
     if (c[j] == c[e[i].q])
      c[j] = c[e[i].p];
    res += sqrt (e[i].len);
    ans1[k] = e[i].p + 1;
    ans2[k] = e[i].q + 1;
    k++;
   }
  printf ("%.6lf\n", res);
  printf ("%d\n", k);
  for (i = 0; i < k; i++)
   printf ("%d %d\n", ans1[i], ans2[i]);
 }
 return 0;
}
