#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>

#define TASKNAME "numbers"

const int LogN = 20, MaxN = 1 << LogN;

int a [MaxN << 1];
int n;

int recur (int left, int right, int p, int lb, int rb)
{
 if (left <= lb && right >= rb - 1) return a[p];
 if (left >= rb || right < lb) return 0;
 int mid;
 mid = (lb + rb) >> 1;
 return recur (left, right, p << 1, lb, mid) +
        recur (left, right, (p << 1) + 1, mid, rb);
}

int main (void)
{
 int i, j, k, l, m, sum;
 freopen (TASKNAME ".in", "rt", stdin);
 freopen (TASKNAME ".out", "wt", stdout);
 while (scanf (" %d %d", &n, &k) != EOF)
 {
  memset (a, 0, sizeof (a));
  for (m = 0; m < k; m++)
  {
   scanf (" %d", &l);
   if (l == 0)
   {
    scanf (" %d %d", &i, &j);
    sum = recur (i, j, 1, 0, MaxN);
    printf ("%d\n", sum);
   }
   else
   {
    for (l += MaxN; l > 0; l >>= 1)
     a[l]++;
   }
  }
 }
 return 0;
}
