import math, random
random.seed (13579)
try:
	import psyco
	psyco.full ()
except:
	pass

MinN = 1
MaxN = 200
MaxC = 1000

def vp (x0, y0, x1, y1, x2, y2):
	return (x1 - x0) * (y2 - y0) - (x2 - x0) * (y1 - y0)

def checklast (x, y, xn, yn):
	n = len (x)
	for i in range (n):
		assert not (x[i] == xn and y[i] == yn)
	for i in range (n - 1):
		for j in range (i + 1, n):
			assert vp (x[i], y[i], x[j], y[j], xn, yn)

def check (x, y):
	n = len (x)
	assert MinN <= n <= MaxN
	assert n == len (y)
	for i in range (n - 1):
		for j in range (i + 1, n):
			assert not (x[i] == x[j] and y[i] == y[j])
	for i in range (n):
		assert -MaxC <= x[i] <= MaxC
		assert -MaxC <= y[i] <= MaxC
	for i in range (n - 2):
		for j in range (i + 1, n - 1):
			for k in range (j + 1, n):
				assert vp (x[i], y[i], x[j], y[j], x[k], y[k])

def out (x, y):
	n = len (x)
	check (x, y)
	print
	print n
	for i in range (n):
		print x[i], y[i]

def gen (n = MaxN, k = 0, xr = MaxC, yr = MaxC, xs = MaxC, ys = MaxC):
        assert MinN <= (n + k) <= MaxN
	x = []
	y = []
	for i in range (n):
		x.append (int (xr * math.cos (i * 2 * math.pi / n)))
		y.append (int (yr * math.sin (i * 2 * math.pi / n)))
	if n:
		check (x, y)
	for i in range (k):
		while True:
		        xn = random.randint (-xs, xs)
		        yn = random.randint (-ys, ys)
			try:
				checklast (x, y, xn, yn)
				break
			except:
				pass
		x.append (xn)
		y.append (yn)
       	check (x, y)
	return x, y

out (*gen (  0,   5,   10,   10,   10,   10))
out (*gen (  5,   0,   10,   10,   10,   10))
out (*gen (  5,   5,   10,   10,   10,   10))
out (*gen (  6,   6,   10,   13,   12,   11))
out (*gen (  8,   6,   10,   13,   12,   11))

out (*gen (  0,  10,  100,  100,  100,  100))
out (*gen ( 10,   0,  100,  100,  100,  100))
out (*gen ( 11,  12,  100,  100,  100,  100))
out (*gen ( 14,   6,  100,  130,  120,  110))
out (*gen (  6,  15,  100,  130,  120,  110))

out (*gen (  0,  15, 1000, 1000, 1000, 1000))
out (*gen ( 55,   0, 1000, 1000, 1000, 1000))
out (*gen ( 15,  35, 1000, 1000, 1000, 1000))
out (*gen ( 40,  30, 1000, 1000, 1000, 1000))
out (*gen ( 20,  23, 1000, 1000, 1000, 1000))

out (*gen (  0,  20,  999, 1000, 1000, 1000))
out (*gen ( 11,  81,  730,  740,  980,  720))
out (*gen ( 10, 100,  434,  550,  200,  300))
out (*gen ( 43,  56,  950,  950,  100,  900))
out (*gen ( 24,  50, 1000, 1000, 1000, 1000))

out (*gen (  0, 140,  100,  110,  400,  300))
out (*gen ( 11, 181,  130,  240,  580,  620))
out (*gen ( 10, 100,  334,  220,  200,  300))
out (*gen ( 43, 156,  250,  350,  300,  200))
out (*gen ( 24, 150,  100,  110,  500,  600))

out (*gen (  0, 200,  999, 1000, 1000, 1000))
out (*gen ( 11, 181,  730,  740,  980,  720))
out (*gen (100, 100,  434,  550,  200,  300))
out (*gen (144,  56,  950,  950,  100,  900))
out (*gen (140,   0, 1000, 1000, 1000, 1000))
