import random
random.seed (13581)
try:
	import psyco
	psyco.full ()
except:
	pass

MinN = 2
MaxN = 10
MaxC = 100

def vp (x0, y0, x1, y1, x2, y2):
	return (x1 - x0) * (y2 - y0) - (x2 - x0) * (y1 - y0)

def checklast (x, y, xn, yn):
	n = len (x)
	for i in range (n):
		assert not (x[i] == xn and y[i] == yn)
	for i in range (n - 1):
		for j in range (i + 1, n):
			assert vp (x[i], y[i], x[j], y[j], xn, yn)

def check (x, y):
	n = len (x)
	assert MinN <= n <= MaxN
	assert n == len (y)
	for i in range (n - 1):
		for j in range (i + 1, n):
			assert not (x[i] == x[j] and y[i] == y[j])
	for i in range (n):
		assert -MaxC <= x[i] <= MaxC
		assert -MaxC <= y[i] <= MaxC
	for i in range (n - 2):
		for j in range (i + 1, n - 1):
			for k in range (j + 1, n):
				assert vp (x[i], y[i], x[j], y[j], x[k], y[k])

def out (x, y):
	n = len (x)
	check (x, y)
	print
	print n
	for i in range (n):
		print x[i], y[i]

def gen (n = MaxN, xs = MaxC, ys = MaxC):
        assert MinN <= n <= MaxN
	x = []
	y = []
	for i in range (n):
		while True:
		        xn = random.randint (-xs, xs)
		        yn = random.randint (-ys, ys)
			try:
				checklast (x, y, xn, yn)
				break
			except:
				pass
		x.append (xn)
		y.append (yn)
       	check (x, y)
	return x, y

out (*gen ( 5,  10,   2))
out (*gen ( 5,  10,  10))

out (*gen ( 6,  25,   2))
out (*gen ( 6,  15,  96))

out (*gen ( 7,  40,  34))
out (*gen ( 7,   2,  16))

out (*gen ( 8,   4,  16))
out (*gen ( 8,  50,  50))

out (*gen ( 9,   7,  84))
out (*gen ( 9,  79,  12))

out (*gen (10,   6,  79))
out (*gen (10, 100, 100))
