#include <stdio.h>
#include <math.h>
#include <vector>
#include <functional>
#include <algorithm>

using namespace std;

#define PII pair<int, int>
#define X first
#define Y second

struct Edge
{
  int A, B;
  double W;
};
       
vector<Edge> E;
int G[200][200], was[200];

struct comp: binary_function <Edge, Edge, bool>
{
  bool operator ()( Edge A, Edge B )
  {
    return A.W < B.W;
  }
};

double Dist( PII A, PII B )
{
  return sqrt((A.X - B.X) * (A.X - B.X) + (A.Y - B.Y) * (A.Y - B.Y));
}

int main( void )
{
  PII P[200];
  int N;
  vector< PII > Ans;
  double sumd = 0;

  freopen("connect.in", "r", stdin);
  freopen("connect.out", "w", stdout);

  scanf("%i", &N);
  for (int i = 0; i < N; i++)
    scanf("%i %i", &P[i].X, &P[i].Y);

  for (int i = 0; i < N; i++)
    for (int j = i + 1; j < N; j++)
    {
      Edge tmp;

      tmp.A = i;
      tmp.B = j;
      tmp.W = Dist(P[i], P[j]);
      E.push_back(tmp);
    }
  sort(E.begin(), E.end(), comp());

  for (int i = 0; i < E.size(); i++)
    if ((was[E[i].B] && !was[E[i].A]) || (!was[E[i].B] && was[E[i].A]) || (!was[E[i].B] && !was[E[i].A]))
    {
      int a, b;

      a = E[i].A;
      b = E[i].B;

      G[E[i].A][E[i].B] = 1;
      G[E[i].B][E[i].A] = 1;
      sumd += E[i].W;
      was[a] = 1;
      was[b] = 1;
    }
  
  for (int i = 0; i < N; i++)
    for (int j = i + 1; j < N; j++)
      if (G[i][j] || G[j][i])
        Ans.push_back(make_pair(i, j));

  printf("%lf\n", sumd);
  printf("%i\n", Ans.size());
  for (int i = 0; i < Ans.size(); i++)
    printf("%i %i\n", Ans[i].X + 1, Ans[i].Y + 1);

  /*
  queue<int> Q;

  Q.push(0);
  while (!Q.empty())
  {
    double mind = -1;
    PII minp;
    int mini, tmp;
    
    tmp = Q.front();
    was[Q.front()] = 1;
    for (int j = 0; j < N; j++)
      if (!was[j])
      {
        double d;

        d = Dist2(P[Q.front()], P[j]);
        if (d < mind || mind == -1)
        {
          mind = d;
          minp = P[j];
          mini = j;
        }
      }

    Q.pop();
    if (mind != -1)
    {
      Ans.push_back(make_pair(tmp, mini));
      Q.push(mini);
      sumd += sqrt(mind);
    }
  }

  printf("%lf\n", sumd);
  printf("%i\n", Ans.size());
  for (int i = 0; (unsigned)i < Ans.size(); i++)
    printf("%i %i\n", Ans[i].X + 1, Ans[i].Y + 1);
  */

  fclose(stdin);
  fclose(stdout);
  return 0;
}
