#pragma comment (linker,"/stack:33554432")

#include <stdio.h>
#include <string.h>
#include <malloc.h>

#define MAX (2 * (1 << 20))
#define Nax (1 << 20)

class TREE
{
private:
  int Tree[MAX], N;
public:

  TREE( void )
  {
    memset(Tree, 0, sizeof(Tree));
    N = 0;
  }

  void Add( int X )
  {
    Tree[Nax + X]++;
    for (int j = (Nax + X) / 2; j > 0; j /= 2)
      Tree[j]++;
  }

  long Get( int L, int R )
  {
    long ret = 0;
    
    L += Nax, R += Nax;
    while (L <= R)
    {
      if (L & 1)
        ret += Tree[L], L++;
      if ((R & 1) == 0)
        ret += Tree[R], R--;
      if (L > R)
        break;
      L /= 2;
      R /= 2;
    }

    return ret;
  }

};

int main( void )
{
  TREE t;
  int N, K;

  /*
  freopen("numbers.in", "w", stdout);

  printf("1000000 100000\n");
  for (int i = 0; i < 100000; i++)
    printf("0 1 1000000\n");

  fclose(stdin);
  */

  freopen("numbers.in", "r", stdin);
  freopen("numbers.out", "w", stdout);

  scanf("%i %i", &N, &K);
  for (int i = 0; i < K; i++)
  {
    int tmp, a, b;
    
    scanf("%i", &tmp);
    if (tmp != 0)
      t.Add(tmp);
    else
    {
      scanf("%i %i", &a, &b);
      printf("%li\n", t.Get(a, b));
    }
  }

  fclose(stdin);
  fclose(stdout);
  return 0;
}
