program CParts;

{$APPTYPE CONSOLE}
{$O-,Q+,R+}

uses
  SysUtils;

type Line = record
    Sx, Sy:Longint;
    Vx, Vy:Longint;
  end;

procedure WriteAns(Ans:Longint);
begin
assign (output, 'parts.out'); rewrite (output);
writeln (Ans);
close (output);
halt;
end;

procedure Swap(var A, B:Real);
var
  T:Real;
begin
T := A;
A := B;
B := T;
end;

var
  LC:Longint;
  L:Array[1..45] of Line;

function II(X, Y:Longint):Boolean;
var
  A1, B1, C1:Longint;
  A2, B2, C2:Longint;
begin
A1 := L[X].Vy; B1 := -L[X].Vx; C1 := L[X].Sy * L[X].Vx - L[X].Sx * L[X].Vy;
A2 := L[Y].Vy; B2 := -L[Y].Vx; C2 := L[Y].Sy * L[Y].Vx - L[Y].Sx * L[Y].Vy;

result := ((A1 * B2 - A2 * B1) = 0);
end;

function Cross(X, Y:Longint):Real;
var
  A1, B1, C1:Longint;
  A2, B2, C2:Longint;
  cX, cY:Real;
begin
A1 := L[X].Vy; B1 := -L[X].Vx; C1 := L[X].Sy * L[X].Vx - L[X].Sx * L[X].Vy;
A2 := L[Y].Vy; B2 := -L[Y].Vx; C2 := L[Y].Sy * L[Y].Vx - L[Y].Sx * L[Y].Vy;

cX := (B1 * C2 - B2 * C1) / (A1 * B2 - A2 * B1);
cY := (C1 * A2 - C2 * A1) / (A1 * B2 - A2 * B1);
if L[X].Vx = 0 then
  result := (cY - L[X].Sy) / L[X].Vy
else
  result := (cX - L[X].Sx) / L[X].Vx;
end;

function Good(A, B, C, X:Longint):Boolean;
var
  G0, G1, G2, G3:Boolean;
  T1, T2, TX:Real;
begin
result := false;
G0 := (not II(A, B)) and (not II(A, C)) and (not II(B, C));
if not G0 then exit;

T1 := Cross(A, B);
T2 := Cross(A, C);
if T1 > T2 then swap (T1, T2);
if T1 = T2 then exit;
if II(A, X) then begin
  G1 := True;
end else begin
  TX := Cross(A, X);
  G1 := (TX <= T1) or (TX >= T2);
end;

T1 := Cross(B, A);
T2 := Cross(B, C);
if T1 > T2 then swap (T1, T2);
if T1 = T2 then exit;
if II(B, X) then begin
  G2 := True;
end else begin
  TX := Cross(B, X);
  G2 := (TX <= T1) or (TX >= T2);
end;

T1 := Cross(C, A);
T2 := Cross(C, B);
if T1 > T2 then swap (T1, T2);
if T1 = T2 then exit;
if II(C, X) then begin
  G3 := True;
end else begin
  TX := Cross(C, X);
  G3 := (TX <= T1) or (TX >= T2);
end;

result := G1 and G2 and G3;
end;

var
  N:Longint;
  Ans:Longint;
  X, Y:Array[1..10] of Longint;
  I, I2, I3, I4:Longint;
  G:Boolean;
begin
assign (input, 'parts.in'); reset (input);
readln (N);
for I := 1 to N do readln (X[I], Y[I]);
close (input);

if N = 2 then writeans (2);
if N = 3 then writeans (7);

LC := 0;
for I := 1 to N do
  for I2 := I + 1 to N do begin
    inc (LC, 1);
    L[LC].Sx := X[I]; L[LC].Sy := Y[I];
    L[LC].Vx := X[I2] - X[I]; L[LC].Vy := Y[I2] - Y[I];
  end;

Ans := 0;
for I := 1 to LC do
  for I2 := I + 1 to LC do
    for I3 := I2 + 1 to LC do begin
      G := True;
      for I4 := 1 to LC do begin
        If I = I4 then continue;
        If I2 = I4 then continue;
        If I3 = I4 then continue;

        G := G And Good(I, I2, I3, I4);
      end;
      if G then
        inc (Ans, 1);
    end;

Ans := Ans + LC * 2;
writeans (Ans);
end.
